//
// ********************************************************************
// *                                                                  *
// *                                                                  *
// *                                                                  *
// ********************************************************************
//


#include "globals.hh"
#include "G4VUserDetectorConstruction.hh"
#include "G4SubtractionSolid.hh"
#include "G4UnionSolid.hh"

class G4Box;
class G4Tubs;
class G4Sphere;
class G4LogicalVolume;
class G4VPhysicalVolume;
class G4Material;
class G4VPVParameterisation;
class G4UserLimits;
class myDetectorMessenger;

// ********************************************************************

class myDetectorConstruction : public G4VUserDetectorConstruction
{
public:
  
  myDetectorConstruction();
  ~myDetectorConstruction();
  
public:
  
  G4VPhysicalVolume* Construct();

public:  
  const G4VPhysicalVolume* GetphysiWorld()  {return physiWorld;};           
  void  SetCenterToDetector(G4double cVal) {centerToDetector = cVal;}
  void  SetDetectorHeight(G4double cVal) {detectorHeight = cVal;}
  void  SetDetectorWidth(G4double cVal) {detectorWidth = cVal;}
  void  SetDetectorAngle(G4double cVal) {detectorAngle = cVal;}
  G4double GetCenterToDetector() {return centerToDetector;}
  G4double GetDetectorHeight() {return detectorHeight;}
  G4double GetDetectorWidth() {return detectorWidth;}
  G4double GetDetectorAngle() {return detectorAngle;}

  //const G4VPhysicalVolume* GetConverter()   {return physiConverter;};
  G4double  GetConverterThickness() {return thickness;}
  void  SetConverterThickness(G4double cVal) {thickness = cVal;}

  void  SetRowColumnID(G4String);
  G4int GetRowID(){return crystalRowID;};
  G4int GetColID(){return crystalColID;};

  
private:

  
  G4Box*             solidWorld;     // pointer to the solid envelope 
  G4LogicalVolume*   logicWorld;     // pointer to the logical envelope
  G4VPhysicalVolume* physiWorld;     // pointer to the physical envelope
 
  //G4Box*             solidMagBox;
  //G4LogicalVolume*   logicMagBox;
  //G4VPhysicalVolume* physiMagBox;

  //G4Box*             solidMybox;     // pointer to the solid envelope 
  //G4LogicalVolume*   logicMybox;     // pointer to the logical envelope
  //G4VPhysicalVolume* physiMybox;     // pointer to the physical envelope
  
  /*  G4Tubs*            solidConverter;    // pointer to the solid Converter
  G4LogicalVolume*   logicConverter;    // pointer to the logical Converter
  G4VPhysicalVolume* physiConverter;    // pointer to the physical Converter
  */

  G4double thickness;
  G4int crystalColID,crystalRowID;
  G4double centerToDetector,detectorHeight,detectorWidth,detectorAngle;
};

// ********************************************************************

