//
// ********************************************************************
// *                                                                  *
// *                                                                  *
// *                                                                  *
// ********************************************************************
//
 
#include "TTree.h"
#include "outTree.h"
#include "G4UserEventAction.hh"
#include "globals.hh"


//#ifndef _hList
//#define _hList
//#endif
//#include "hList.hh"

//extern mcHistos_t myHistos2;

class myPrimaryGeneratorAction;

class G4Event;

// ********************************************************************

class myEventAction : public G4UserEventAction
{
public:
  myEventAction(myPrimaryGeneratorAction*);
  ~myEventAction();
  
public:
  void SetOutTree(TTree*);
  void SetOutTreeStruct(crystalArray_t *sTmp){crystalArrayPtr = sTmp;};
  void BeginOfEventAction(const G4Event*);
  void EndOfEventAction(const G4Event*);
  void AddMyEnergyPaddle1(G4double de) {
    energyPaddle1 += de;
    //Same as energyPaddle1 = de + energyPaddle1;
  }
  void AddMyEnergyPaddle2(G4double de) {
    energyPaddle2 += de;
    //Same as energyPaddle1 = de + energyPaddle1;
  }

  void AddCrystalEnergy(G4double de, G4int rowID, G4int colID) {crystalEnergy[rowID][colID] += de;}
  G4double GetCrystalEnergy(G4int rowID,G4int colID){return crystalEnergy[rowID][colID];};

  
  G4double energyPaddle1,energyPaddle2;
  myPrimaryGeneratorAction* primary;

  TTree* outTree;
  crystalArray_t *crystalArrayPtr;
  G4double crystalEnergy[10][10];
  //#include "hList.hh"
  //mcHistos_t myHistosTmp1;

};

// ********************************************************************


    
