//
// ********************************************************************
// *                                                                  *
// *                                                                  *
// *                                                                  *
// ********************************************************************
//
 

#include "G4VUserPrimaryGeneratorAction.hh"
#include "TTree.h"
#include "globals.hh"

class myDetectorConstruction;
class G4ParticleGun;
class G4Event;

// ********************************************************************
 
class myPrimaryGeneratorAction : public G4VUserPrimaryGeneratorAction
{
public:
  myPrimaryGeneratorAction(myDetectorConstruction*);    
  ~myPrimaryGeneratorAction();
  
public:
  void GeneratePrimaries(G4Event*);
  void SetGenTree(TTree*);
  void SetWeightXSpointer(double*);
  void SetDeltaE12pointer(double*);
  G4double GetThetaR(){return thetaR;};
  G4double GetPhiR(){return phiR;};
  G4double GetMoR(){return moR;};
  G4double GetKeR(){return keR;};
  G4double GetWeightXS(){return weightXS;};
  G4double GetDeltaE12(){return deltaE12;};
  void  SetConverterThickness(G4double cVal) {converterThickness = cVal;}
  void  SetBeamMomentum(G4double pVal) {beamMomentum = pVal;}
  void  SetConverterZ(G4double zVal) {converterZ = zVal;}
  void  SetBeamType(G4int bVal) {beamType = bVal;}
  void  SetBeamX(G4double xVal) {xOffset = xVal;}
  void  SetBeamY(G4double yVal) {yOffset = yVal;}
  void  SetSpotRadius(G4double sVal) {spotRadius = sVal;}
  void  SetEventsToSkip(G4int skipVal) {nToSkip = skipVal;}

  //void  SetMoE(G4double mo) {moE = mo;}
  G4double GetBeamMomentum(){return beamMomentum;};

  G4double GetPosX(){return posX;}
  G4double GetPosY(){return posY;}
  G4double GetEnergy(){return beamEnergy;}

private:
  G4ParticleGun* particleGun;
  myDetectorConstruction* myDetector;
  TTree* genTree;
  G4int nToSkip;
  G4double thetaR,keR,moR,phiR,deltaE12,weightXS;
  G4double moE,mE,beamMomentum;
  G4double converterThickness,converterZ,beamType;
  G4double xOffset,yOffset,spotRadius;
  G4double beamEnergy,posX,posY,posZ;
};

// ********************************************************************



