
#include "mySteppingAction.hh"
#include "myDetectorConstruction.hh"
#include "myEventAction.hh"
#include "myPrimaryGeneratorAction.hh"
#include "G4Step.hh"
#include "TH2.h"
#include "TLorentzVector.h"

#include "G4ElectronIonPair.hh"
#include "G4Material.hh"
#include "G4MaterialTable.hh"

#include "G4SystemOfUnits.hh"

#include "hList.hh"
//mcHistos_t myHistos;

mySteppingAction::mySteppingAction(myDetectorConstruction* det,
					   myEventAction* evt,
					   myPrimaryGeneratorAction* pri)
  :detector(det), eventaction(evt), primary(pri)
{ }


mySteppingAction::~mySteppingAction()
{ }

void mySteppingAction::UserSteppingAction(const G4Step* aStep)
{
  extern struct mcHistos_t myHistos;

  // get volume of the current step
  G4VPhysicalVolume* volume = aStep->GetPreStepPoint()->GetTouchableHandle()->GetVolume();

  //Get the energy deposition for the step
  G4double edep = aStep->GetTotalEnergyDeposit();
 
  G4StepPoint* prePoint = aStep->GetPreStepPoint();
  G4StepPoint* postPoint = aStep->GetPostStepPoint();
  G4ThreeVector positionPost = postPoint->GetPosition();

  G4TouchableHandle touch1 = prePoint->GetTouchableHandle();

  //Find the volume of the pre and post-step points                             
  G4VPhysicalVolume* preVolume = touch1->GetVolume();
  G4String preVolumeName       = preVolume->GetName();
  G4Track* p1track             = aStep->GetTrack();
  G4int parentId               = p1track->GetParentID();
  G4ParticleDefinition* outParticle = p1track->GetDefinition();

  G4ThreeVector prePos = prePoint->GetPosition();

  extern struct mcHistos_t myHistos; //Get the list of histograms
  if (postPoint->GetStepStatus() == fGeomBoundary){ //See if particle is at geometry boundary
    if (preVolumeName == "DetectorPlane" && parentId == 0 ) { //See if the point is leaving the DetectorPlane
      //double rotationAngleZ = 23.0; //HARDCODED FOR NOW. LATER WILL MAKE A COMMAND-LINE VARIABLE            
      //prePos.rotate(-1*rotationAngleZ,G4ThreeVector(0,0,1)); //Rotate about z
      prePos.rotate(-1*detector->GetDetectorAngle(),G4ThreeVector(0,0,1)); //Rotate about z
      myHistos.hHitXY->Fill(prePos.y()/cm,prePos.z()/cm); //Fill the histogram         
      if (fabs(prePos.z())<cm/2) myHistos.hSino->Fill(prePos.y()/cm,detector->GetDetectorAngle()/degree);
    }
  }


  //asdf TH1D *hHit;
  //asdf TH1D *hHitSecondary;
  //G4cout<<"preVolumeName = "<<preVolumeName<<G4endl;
  //G4cout<<"prePosition = "<<prePos.x()/cm<<" , "<<prePos.y()/cm<<" , "<<prePos.z()/cm<<G4endl;
  //extern struct mcHistos_t myHistos;
  //detector->SetRowColumnID(volume->GetName());
  //G4int crystalRowID = detector->GetRowID();
  //G4int crystalColID = detector->GetColID();
  //if (crystalRowID > -1 && crystalColID > -1) {
  //myHistos.hEDep->Fill(prePos.x()/cm,prePos.y()/cm,edep);
  //eventaction->AddCrystalEnergy(edep,crystalRowID,crystalColID);
  //}

  //eventaction->AddMyEnergyPaddle1(edep);
  //if (postPoint->GetStepStatus() == fGeomBoundary){
  //if (preVolumeName == "Plate" && parentId == 0 ) {
      //myHistos.hHit->Fill(prePos.z()/cm);
      
  //}
  //if (preVolumeName == "Plate" && parentId != 0 && outParticle->GetParticleName() == "e-") {
      //myHistos.hHitSecondary->Fill(detector->GetConverterThickness()/um);
  //}
  //}
}
